/*
 * dispatcher.cpp
 *
 *  Created on: 20.01.2010
 *      Author: afestini
 */

#include "dispatcher.h"
#include <boost/foreach.hpp>
#include "selector.h"

void Dispatcher::registerConnection( const Connection& connection )
{
	connections.push_back(connection);
}

void Dispatcher::dispatch() const
{
	Selector s;

	int minTimeout = -1;
	BOOST_FOREACH(const Connection& c, connections)
	{
		if (c.getFD)
			s.addFD(c.getFD());

		int timeout = c.getTimeout ? c.getTimeout() : -1;

		if ( timeout >= 0 && (minTimeout < 0 || timeout < minTimeout) )
			minTimeout = timeout;
	}

	s.setTimeout( minTimeout );
	int res = s.select();

	BOOST_FOREACH(const Connection& c, connections)
	{
		if ( res == 0 && c.getTimeout )//&& c.getTimeout() == 0 )
			c.onTimeout();

		if ( res > 0 && c.getFD && s.checkFD(c.getFD()) )
			c.onData();
	}
}
