/*
 * dispatcher.h
 *
 *  Created on: 20.01.2010
 *      Author: afestini
 */

#ifndef DISPATCHER_H_
#define DISPATCHER_H_

#include <boost/function.hpp>
#include <list>

struct Connection
{
	boost::function<int()> getFD, getTimeout;
	boost::function<void()> onData, onTimeout;
};

class Dispatcher
{
	std::list<Connection> connections;

public:
	void registerConnection( const Connection& connection );
	void dispatch() const;
};

#endif /* DISPATCHER_H_ */
