/*
 * memfunc.h
 *
 *  Created on: 27.07.2009
 *      Author: afestini
 */

#ifndef MEMFUNC_H_
#define MEMFUNC_H_

template<class R, class C>
class MemFuncBond
{
protected:
	typedef R(C::*Func)();
	C& object_;
	Func function_;
public:
	explicit MemFuncBond(Func func, C& object) : object_(object), function_(func) {}
	R operator()() { return (object_.*function_)(); }
};

template<class R, class T, class O>
MemFuncBond<R, T> binder( R(T::*functionPtr)(), O& object ) { return MemFuncBond<R,T>(functionPtr, object); }

#endif /* MEMFUNC_H_ */
