/*
 * timing.h
 *
 *  Created on: 31.07.2009
 *      Author: afestini
 *
 *  Primitive clock using the monotonic timer (usually time since startup,
 *  not influenced by setting time). Clock::time() returns time since first
 *  call to Clock::time() in ms.
 */

#ifndef TIMING_H_
#define TIMING_H_

class Clock
{
	static timespec getStartTime()
	{
		timespec time;
		clock_gettime(CLOCK_MONOTONIC, &time);
		return time;
	}

public:

	static unsigned time()
	{
		static const timespec startTime = getStartTime();

		timespec t;
		clock_gettime(CLOCK_MONOTONIC, &t);
		return (t.tv_sec - startTime.tv_sec)*1000 + (t.tv_nsec - startTime.tv_nsec)/1000000;
	}
};

#endif /* TIMING_H_ */
